/*************************************************************************************************
 **  PROGRAM - Dragons and Treasure                         *  AUTHOR: Jerry Baldwin            **
 **  Started - 03/23/2014                                   *                                   **
 **  Finished - 07/05/2017                                  **************************************
 **  Last Edit Date & Time - 21:00  07/05/2017                                                  **
 **  Purpose - D&T game board updates and converted to graphics                                 **
 *************************************************************************************************/
#define ALLEGRO_STATICLINK
#include <allegro.h>
#include <iostream>
#include <d_array.h>
#include <string>
#include <cstdio>
#include <allcolor.h>
#include <fstream>
#include <Dragons.h>

using namespace std;

#define RIGHT 164            // Location where to start squares
#define DOWN 100
#define SQ_SIZE 32             // Square size in pixels
#define H_SIZE 10              // Jump for Wall thickness squares
#define V_SIZE 10


void target(char[][15],BITMAP *[],bchar [],int,DATAFILE*);
void board_status(char[][15],bchar []);
int random_no(int);
void draw_board(char[][15],BITMAP *[],bchar [],DATAFILE*);
int map(char[][15]);

/************************************* Board Init ********************************************************/
void board_init(char board[][15],char walls[][15],BITMAP *GameBitmaps[],bchar token[],int sound_clip,DATAFILE *GameDat){

	for(int y_count=0;y_count<15;y_count++){                          //Initialize Board
	   for(int x_count=0;x_count<15;x_count++){
	      if((x_count %2 == 0) && (y_count %2 == 0))
	         board[x_count][y_count]= '.';
	      if((x_count %2 != 0) && (y_count %2 == 0))
	         board[x_count][y_count]= '|';
	      if((x_count %2 != 0) && (y_count %2 != 0))     // Prevents Junk in array
             board[x_count][y_count]= 'X';
          if((x_count %2 == 0) && (y_count %2 != 0))
             board[x_count][y_count]= '-';  }}

	map(walls);

	token[PLAYER].piece = 'P';
	token[DRAGON].piece = '.';
	token[TREASURE].piece = '.';
	token[ESCAPE].piece = 'S';

    target(board,GameBitmaps,token,sound_clip,GameDat); // Player Chooses Starting Point

    do{ // confirms the random placement of Dragon and Treasure doesn't fall on Player's Square
    	token[DRAGON].x = (random_no(8)*2);
	    rest(300);

      	token[TREASURE].x = (random_no(8)*2);
    	rest(300);

        token[DRAGON].y = (random_no(8)*2);
        rest(300);

	    token[TREASURE].y = (random_no(8)*2);

     }while ((token[TREASURE].x == token[PLAYER].x && token[TREASURE].y == token[PLAYER].y) ||
    		(token[DRAGON].x == token[PLAYER].x && token[DRAGON].y == token[PLAYER].y ));

	token[ESCAPE].x = token[PLAYER].x ;
	token[ESCAPE].y = token[PLAYER].y;

	board[token[ESCAPE].x][token[ESCAPE].y] = token[ESCAPE].piece;
	board[token[TREASURE].x][token[TREASURE].y] = token[TREASURE].piece;
	board[token[PLAYER].x][token[PLAYER].y] = token[PLAYER].piece;
	board[token[DRAGON].x][token[DRAGON].y] = token[DRAGON].piece;


}// End board_init();

/************************************** Board Status *******************************************************/

void board_status(char board[][15],bchar token[]){

	for(int y_count=0;y_count<15;y_count++){                          //Zero Board ROOMS ONLY for Update
	   for(int x_count=0;x_count<15;x_count++){
	      if((x_count %2 == 0) && (y_count %2 == 0))
	         board[x_count][y_count]= '.';                        
	   }}
	board[token[ESCAPE].x][token[ESCAPE].y] = token[ESCAPE].piece;
	board[token[PLAYER].x][token[PLAYER].y] = token[PLAYER].piece;
	board[token[TREASURE].x][token[TREASURE].y] = token[TREASURE].piece;
	board[token[DRAGON].x][token[DRAGON].y] = token[DRAGON].piece;

}// End board_status();

/******************************************************************************************************/

void draw_board(char board[][15],BITMAP *GameBitmaps[],bchar token[],DATAFILE *GameDat){


	board_status(board,token);
	blit ((BITMAP *)GameDat[GAME_BACK].dat,GameBitmaps[BUFFER],0, 0,0,0,640,480);
    int iAcrossAccum = RIGHT;
    int iDownAccum = DOWN;

    for(int y=0;y<15;y++){
		 for(int x=0;x<15;x++){
			  if(board[x][y]=='|')
			    blit ((BITMAP *)GameDat[V_GAP].dat,GameBitmaps[BUFFER], 0, 0,iAcrossAccum,iDownAccum,640,480);
			  if(board[x][y]=='/')
			    blit ((BITMAP *)GameDat[V_WALL].dat,GameBitmaps[BUFFER], 0, 0,iAcrossAccum,iDownAccum,640,480);
			  if(board[x][y] == '.')
			    blit ((BITMAP *)GameDat[EMPTY_SQ].dat,GameBitmaps[BUFFER], 0, 0,iAcrossAccum,iDownAccum,640,480);
			  if(board[x][y] == 'T')
			    blit ((BITMAP *)GameDat[TREASURE_SQ].dat,GameBitmaps[BUFFER], 0, 0,iAcrossAccum,iDownAccum,640,480);
	          if(board[x][y] == 'P')
			    blit ((BITMAP *)GameDat[PLAYER_SQ].dat,GameBitmaps[BUFFER], 0, 0,iAcrossAccum,iDownAccum,640,480);
              if(board[x][y] == '-')
	        	blit ((BITMAP *)GameDat[H_GAP].dat,GameBitmaps[BUFFER], 0, 0,iAcrossAccum,iDownAccum,640,480);
              if(board[x][y] == '#')
  	        	blit ((BITMAP *)GameDat[H_WALL].dat,GameBitmaps[BUFFER], 0, 0,iAcrossAccum,iDownAccum,640,480);
			  if(board[x][y] == 'V')
			    blit ((BITMAP *)GameDat[VICTORY_SQ].dat,GameBitmaps[BUFFER], 0, 0,iAcrossAccum,iDownAccum,640,480);
			  if(board[x][y] == 'G')
			    blit ((BITMAP *)GameDat[TREASURE_G_SQ].dat,GameBitmaps[BUFFER], 0, 0,iAcrossAccum,iDownAccum,640,480);
			  if(board[x][y] == 'C')
			    blit ((BITMAP *)GameDat[PLAY_T_SQ].dat,GameBitmaps[BUFFER], 0, 0,iAcrossAccum,iDownAccum,640,480);
			  if(board[x][y] == 'S')
			   blit ((BITMAP *)GameDat[ESC_SQ].dat,GameBitmaps[BUFFER], 0, 0,iAcrossAccum,iDownAccum,640,480);
			  if(board[x][y] == 'M')
			   blit ((BITMAP *)GameDat[TARGET_SQ].dat,GameBitmaps[BUFFER], 0, 0,iAcrossAccum,iDownAccum,640,480);
	          if(board[x][y] == 'F')
			    blit ((BITMAP *)GameDat[DRAGON_SQ].dat,GameBitmaps[BUFFER], 0, 0,iAcrossAccum,iDownAccum,640,480);
	          if(board[x][y] == 'D')
	  	       	blit ((BITMAP *)GameDat[DEATH_SQ].dat,GameBitmaps[BUFFER], 0, 0,iAcrossAccum,iDownAccum,640,480);

			  if(x%2==0)
               iAcrossAccum+=SQ_SIZE;
              else iAcrossAccum +=H_SIZE;

	    } //end fcor X Loop
	 iAcrossAccum=RIGHT;
    if(y%2==0)
	  iDownAccum+=SQ_SIZE;
	else iDownAccum +=V_SIZE;


	 } // end for Y Loop

	blit (GameBitmaps[BUFFER],screen,0,0,0,0,640,480);


}// End draw_board();

