/*************************************************************************************************
 **  PROGRAM - Dragons and Treasure                         *  AUTHOR: Jerry Baldwin            **
 **  Started - 11/04/13                                     *                                   **
 **  Finished -0705/17                                      **************************************
 **  Last Edit Date & Time - 20:50 07/05/17                                                     **
 **  Purpose - Title Screen for D&T                                                             **
 *************************************************************************************************/
#define ALLEGRO_STATICLINK
#include <allegro.h>
#include <iostream>
#include <string>
#include <cstdio>
#include <allcolor.h>
#include <d_array.h>
#include <Dragons.h>
#include <fstream>
using namespace std;

// Called Functions

int dragons(BITMAP *[], DATAFILE*);
void titlescr(BITMAP *[], DATAFILE*);
void instruct(BITMAP *[], DATAFILE*);
void credits(BITMAP *[], DATAFILE*);


/***************** Function for the Menu Choices ***************************/
char menu(BITMAP * GameBitmaps[], DATAFILE *GameDat) {
	int resp = 0;
    titlescr(GameBitmaps,GameDat);
	//	FONT *menu_font = load_font("Old_Eng_24.pcx", NULL, NULL);
	textprintf_ex(GameBitmaps[BUF_HOLD], (FONT*) GameDat[Old_Eng_24].dat, 135,300, DK_GRAY, -1, "Play Game");
	textprintf_ex(GameBitmaps[BUF_HOLD], (FONT*) GameDat[Old_Eng_24].dat, 135,300, BR_YELLOW, -1, "P");
	textprintf_ex(GameBitmaps[BUF_HOLD], (FONT*) GameDat[Old_Eng_24].dat, 360,300, DK_GRAY, -1, "Instructions");
	textprintf_ex(GameBitmaps[BUF_HOLD], (FONT*) GameDat[Old_Eng_24].dat, 360,300, BR_YELLOW, -1, "I");
	textprintf_ex(GameBitmaps[BUF_HOLD], (FONT*) GameDat[Old_Eng_24].dat, 135,360, DK_GRAY, -1, "Quit Game");
	textprintf_ex(GameBitmaps[BUF_HOLD], (FONT*) GameDat[Old_Eng_24].dat, 135,360, BR_YELLOW, -1, "Q");
	textprintf_ex(GameBitmaps[BUF_HOLD], (FONT*) GameDat[Old_Eng_24].dat, 360,360, DK_GRAY, -1, "Credits");
	textprintf_ex(GameBitmaps[BUF_HOLD], (FONT*) GameDat[Old_Eng_24].dat, 360,360, BR_YELLOW, -1, "C");

	while(resp != KEY_Q && resp != KEY_I && resp != KEY_C && resp != KEY_P)
                 resp = dragons(GameBitmaps, GameDat); //  ReadKey function for Resp for desired actions
   return(resp);
} //End Menu()
/*************** Function for Title Screen Background  ******************/
void titlescr(BITMAP *GameBitmaps[], DATAFILE *GameDat) {

   blit((BITMAP*) GameDat[TITLE_BACK].dat, GameBitmaps[BUF_HOLD], 0, 0, 0, 0, 640, 480);
	textprintf_ex(GameBitmaps[BUF_HOLD], (FONT*) GameDat[Old_Eng_72B].dat, 50, 20, DKRED, -1, "Dragons &");
	textprintf_ex(GameBitmaps[BUF_HOLD], (FONT*) GameDat[Old_Eng_72].dat, 53, 20, BR_YELLOW, -1, "Dragons &");
	textprintf_ex(GameBitmaps[BUF_HOLD], (FONT*) GameDat[Old_Eng_72B].dat, 190,120, DKRED, -1, "Treasures");
	textprintf_ex(GameBitmaps[BUF_HOLD], (FONT*) GameDat[Old_Eng_72].dat, 195, 120, BR_YELLOW, -1, "Treasures");
	
} // End titelscr()
/**************** Function for viewing Game Instructions **********************/
void instruct(BITMAP * GameBitmaps[], DATAFILE *GameDat)
{
	int resp = 0;
	int count = 0;
    int test = 0;
	blit((BITMAP *) GameDat[INST_BACK].dat, GameBitmaps[BUF_HOLD], 0, 0, 0, 0, 640, 480);
	rectfill((BITMAP *) GameBitmaps[2], 0, 0, 640, 480, DKRED);
	blit((BITMAP *) GameDat[TARGET_SQ].dat, GameBitmaps[2], 0, 0, 13,16, 640, 480);
	blit((BITMAP *) GameDat[ESC_SQ].dat, GameBitmaps[2], 0, 0, 58,16, 640, 480);
	blit((BITMAP *) GameDat[H_WALL].dat, GameBitmaps[2], 0, 0, 103,26, 640, 480);
	blit((BITMAP *) GameDat[V_WALL].dat, GameBitmaps[2], 0, 0, 138,16, 640, 480);
	blit((BITMAP *) GameDat[DRAGON_SQ].dat, GameBitmaps[2], 0, 0, 163,16, 640, 480);
	blit((BITMAP *) GameDat[PLAYER_SQ].dat, GameBitmaps[2], 0, 0, 208,16, 640, 480);
	blit((BITMAP *) GameDat[PLAY_T_SQ].dat, GameBitmaps[2], 0, 0, 253,16, 640, 480);
	blit((BITMAP *) GameDat[TREASURE_SQ].dat, GameBitmaps[2], 0, 0, 298,16, 640, 480);
	blit((BITMAP *) GameDat[TREASURE_G_SQ].dat, GameBitmaps[2], 0, 0, 343,16, 640, 480);
	blit((BITMAP *) GameDat[VICTORY_SQ].dat, GameBitmaps[2], 0, 0, 388,16, 640, 480);
	blit((BITMAP *) GameDat[DEATH_SQ].dat, GameBitmaps[2], 0, 0, 433,16, 640, 480);
	blit((BITMAP *) GameDat[INST_WAKE].dat, GameBitmaps[2], 0, 0, 332,141, 640, 480);


	textprintf_ex(GameBitmaps[BUF_HOLD], (FONT*) GameDat[KingsQ_16].dat, 210, 120, BR_YELLOW, -1, "Playing Instructions");
	textprintf_ex(GameBitmaps[2], (FONT*) GameDat[KingsQ_12].dat, 0, 0, BR_YELLOW, -1,    "Game Pieces:");
	textprintf_ex(GameBitmaps[2], (FONT*) GameDat[KingsQ_10].dat, 10, 45, BR_GREEN, -1,    "Target");
	textprintf_ex(GameBitmaps[2], (FONT*) GameDat[KingsQ_10].dat, 59, 45, BR_GREEN, -1,    "Entry");
	textprintf_ex(GameBitmaps[2], (FONT*) GameDat[KingsQ_10].dat, 110, 50, BR_GREEN, -1,    "Walls");
	textprintf_ex(GameBitmaps[2], (FONT*) GameDat[KingsQ_10].dat, 160, 50, BR_GREEN, -1,    "Dragon");
	textprintf_ex(GameBitmaps[2], (FONT*) GameDat[KingsQ_10].dat, 208, 50, BR_GREEN, -1,    "Player");
	textprintf_ex(GameBitmaps[2], (FONT*) GameDat[KingsQ_10].dat, 253, 45, BR_GREEN, -1,    "Player");
	textprintf_ex(GameBitmaps[2], (FONT*) GameDat[KingsQ_10].dat, 291, 45, BR_GREEN, -1,    "Treasure");
	textprintf_ex(GameBitmaps[2], (FONT*) GameDat[KingsQ_10].dat, 344, 45, BR_GREEN, -1,    "Empty");
	textprintf_ex(GameBitmaps[2], (FONT*) GameDat[KingsQ_10].dat, 383, 50, BR_GREEN, -1,    "Victory");
	textprintf_ex(GameBitmaps[2], (FONT*) GameDat[KingsQ_10].dat, 433, 50, BR_GREEN, -1,    "Death");
	textprintf_ex(GameBitmaps[2], (FONT*) GameDat[KingsQ_10].dat, 12, 56, BR_GREEN, -1,    "Square");
	textprintf_ex(GameBitmaps[2], (FONT*) GameDat[KingsQ_10].dat, 60, 56, BR_GREEN, -1,    "Point");
	textprintf_ex(GameBitmaps[2], (FONT*) GameDat[KingsQ_10].dat, 246, 56, BR_GREEN, -1,    "Treasure");
	textprintf_ex(GameBitmaps[2], (FONT*) GameDat[KingsQ_10].dat, 298, 56, BR_GREEN, -1,    "Chest");
	textprintf_ex(GameBitmaps[2], (FONT*) GameDat[KingsQ_10].dat, 344, 56, BR_GREEN, -1,    "Chest");

	textprintf_ex(GameBitmaps[2], (FONT*) GameDat[KingsQ_12].dat, 0, 69, DK_GRAY, -1,    "Goal: Capture the treasure and make it back to your entry point");
	textprintf_ex(GameBitmaps[2], (FONT*) GameDat[KingsQ_12].dat, 0, 69, BR_YELLOW, -1,  "Goal: ");
	textprintf_ex(GameBitmaps[2], (FONT*) GameDat[KingsQ_12].dat, 0, 83, DK_GRAY, -1,   " without running into the Dragon.");
	textprintf_ex(GameBitmaps[2], (FONT*) GameDat[KingsQ_12].dat, 0, 97, DK_GRAY, -1,	"Choose Entry Square: Using the four arrow keys move Target piece");
	textprintf_ex(GameBitmaps[2], (FONT*) GameDat[KingsQ_12].dat, 0, 97,  BR_YELLOW,-1, "Choose Entry Square:");
	textprintf_ex(GameBitmaps[2], (FONT*) GameDat[KingsQ_12].dat, 0, 111, DK_GRAY, -1,	" to any square on the board & hit Enter");
	textprintf_ex(GameBitmaps[2], (FONT*) GameDat[KingsQ_12].dat, 0, 125, DK_GRAY, -1,	"Player Move: Using the arrow keys, move horizontally or vertically");
	textprintf_ex(GameBitmaps[2], (FONT*) GameDat[KingsQ_12].dat, 0, 125, BR_YELLOW, -1, "Player Move:");
	textprintf_ex(GameBitmaps[2], (FONT*) GameDat[KingsQ_12].dat, 0, 139, DK_GRAY, -1,	" 1 square at a time. A single turn totals 6 ");
	textprintf_ex(GameBitmaps[2], (FONT*) GameDat[KingsQ_12].dat, 0, 153, DK_GRAY, -1,	" squares unless the Player runs into a wall.");
	textprintf_ex(GameBitmaps[2], (FONT*) GameDat[KingsQ_12].dat, 0, 167, DK_GRAY, -1,	" When the Player moves within 2 squares of the ");
	textprintf_ex(GameBitmaps[2], (FONT*) GameDat[KingsQ_12].dat, 0, 181, DK_GRAY, -1,	" Treasure Square, the Dragon will awaken & be");
	textprintf_ex(GameBitmaps[2], (FONT*) GameDat[KingsQ_12].dat, 0, 195, DK_GRAY, -1,	" displayed in a random square on the board. The");
	textprintf_ex(GameBitmaps[2], (FONT*) GameDat[KingsQ_12].dat, 0, 209, DK_GRAY, -1,	" Player can run into the Dragon before his is");
	textprintf_ex(GameBitmaps[2], (FONT*) GameDat[KingsQ_12].dat, 0, 223, DK_GRAY, -1,	" visible. When the treasure is found, the");
	textprintf_ex(GameBitmaps[2], (FONT*) GameDat[KingsQ_12].dat, 0, 237, DK_GRAY, -1,  " Player's turn drops from 6 to 4 squares.");
	textprintf_ex(GameBitmaps[2], (FONT*) GameDat[KingsQ_12].dat, 0, 251, DK_GRAY, -1,	"Dragon Moves: The Dragon starts the game");
	textprintf_ex(GameBitmaps[2], (FONT*) GameDat[KingsQ_12].dat, 0, 251, BR_YELLOW, -1,"Dragon Moves:");
	textprintf_ex(GameBitmaps[2], (FONT*) GameDat[KingsQ_12].dat, 0, 265, DK_GRAY, -1,  " asleep & hidden. It will not move between");
	textprintf_ex(GameBitmaps[2], (FONT*) GameDat[KingsQ_12].dat, 0, 279, DK_GRAY, -1,  " turns. Once awaken it will move 1 square each turn towards");
	textprintf_ex(GameBitmaps[2], (FONT*) GameDat[KingsQ_12].dat, 0, 293, DK_GRAY, -1,  " the Player. The Dragon's move and direction isn't affected by walls.");
	textprintf_ex(GameBitmaps[2], (FONT*) GameDat[KingsQ_12].dat, 0, 307, DK_GRAY, -1,  "Victory: The game is won when the Player finds the Treasure Square");
	textprintf_ex(GameBitmaps[2], (FONT*) GameDat[KingsQ_12].dat, 0, 307, BR_YELLOW, -1,"Victory:");
	textprintf_ex(GameBitmaps[2], (FONT*) GameDat[KingsQ_12].dat, 0, 321, DK_GRAY, -1,  " & carries the treasure back to the Entry Square.");
	textprintf_ex(GameBitmaps[2], (FONT*) GameDat[KingsQ_12].dat, 0, 335, DK_GRAY, -1,  "Death of a Noble Warrior: The game is lost when the Player makes ");
	textprintf_ex(GameBitmaps[2], (FONT*) GameDat[KingsQ_12].dat, 0, 335, BR_YELLOW, -1,"Death of a Noble Warrior:");
	textprintf_ex(GameBitmaps[2], (FONT*) GameDat[KingsQ_12].dat, 0, 349, DK_GRAY, -1,  " contact with the Dragon. ");
	textprintf_ex(GameBitmaps[2], (FONT*) GameDat[KingsQ_12].dat, 0, 363, DK_GRAY, -1,	"Quit:  Once the game starts, the Player can quit at any time by ");
	textprintf_ex(GameBitmaps[2], (FONT*) GameDat[KingsQ_12].dat, 0, 363, BR_YELLOW, -1,"Quit:");
	textprintf_ex(GameBitmaps[2], (FONT*) GameDat[KingsQ_12].dat, 0, 377, DK_GRAY, -1,  " hitting the Q key");
	textprintf_ex(GameBitmaps[BUF_HOLD], (FONT*) GameDat[KingsQ_12].dat, 88, 424, BR_RED, -1, "Space Bar Returns to Title Screen. Up/Down to Scroll Instructions");
	blit((BITMAP *) GameBitmaps[2], GameBitmaps[BUF_HOLD], 0, count, 78, 153, 483, 260);


    while(resp != KEY_SPACE){
          resp = dragons(GameBitmaps, GameDat); //  ReadKey function for Resp for desired actions
	     if(resp == KEY_UP && count >= 10){
	    	count -= 10;
	        blit((BITMAP *) GameBitmaps[2], GameBitmaps[BUF_HOLD], 0, count, 78, 153, 483, 260);
	     }
	     if(resp == KEY_DOWN && count <= 135){
	       	count += 10;
	        blit((BITMAP *) GameBitmaps[2], GameBitmaps[BUF_HOLD], 0, count, 78, 153, 483, 260);
	     }
    }//While
} //End Instruct()

/**************** Function for viewing Game Credits **********************/

void credits(BITMAP * GameBitmaps[], DATAFILE *GameDat) {
    int resp = 0;

    titlescr(GameBitmaps,GameDat);

   	blit((BITMAP*) GameDat[TITLE_BACK].dat, GameBitmaps[BUF_HOLD], 0, 0, 0, 0,640, 480);
	textprintf_ex(GameBitmaps[BUF_HOLD], (FONT*) GameDat[KingsQ_16].dat, 270, 253, BR_YELLOW, -1, "CREDITS");
	textprintf_ex(GameBitmaps[BUF_HOLD], (FONT*) GameDat[KingsQ_12].dat, 95, 278, DK_GRAY, -1,   "Title Screen Background Art:");
	textprintf_ex(GameBitmaps[BUF_HOLD], (FONT*) GameDat[KingsQ_12].dat, 293, 278, BR_YELLOW, -1, " Death Dealer by Frank Frazetti");
	textprintf_ex(GameBitmaps[BUF_HOLD], (FONT*) GameDat[KingsQ_12].dat, 95, 292, DK_GRAY, -1,   "Game Board Art:");
	textprintf_ex(GameBitmaps[BUF_HOLD], (FONT*) GameDat[KingsQ_12].dat, 205, 292, BR_YELLOW, -1, " Based on Mattel's Electronic Dungeons and Dragons");
	textprintf_ex(GameBitmaps[BUF_HOLD], (FONT*) GameDat[KingsQ_12].dat, 95, 306, DK_GRAY, -1,   "Dragons Sprites:");
	textprintf_ex(GameBitmaps[BUF_HOLD], (FONT*) GameDat[KingsQ_12].dat, 205, 306, BR_YELLOW, -1, " from Atari's Adventure by Warren Robinett");
	textprintf_ex(GameBitmaps[BUF_HOLD], (FONT*) GameDat[KingsQ_12].dat, 95, 320, DK_GRAY, -1,   "Game Programmer/Designer:");
	textprintf_ex(GameBitmaps[BUF_HOLD], (FONT*) GameDat[KingsQ_12].dat, 270, 320, BR_YELLOW, -1, " Jerry Baldwin");
	textprintf_ex(GameBitmaps[BUF_HOLD], (FONT*) GameDat[KingsQ_12].dat, 95, 338, DK_GRAY, -1,   "All artwork are properties of their respective creators / companies");
	textprintf_ex(GameBitmaps[BUF_HOLD], (FONT*) GameDat[KingsQ_12].dat, 95, 350, DK_GRAY, -1,	 "and should not be duplicated or sold without written consent of ");
	textprintf_ex(GameBitmaps[BUF_HOLD], (FONT*) GameDat[KingsQ_12].dat, 95, 362, DK_GRAY, -1,   "the respective owners.");
	textprintf_ex(GameBitmaps[BUF_HOLD], (FONT*) GameDat[KingsQ_12].dat, 95, 374, DK_GRAY, -1,   "Game code was programmed as a learning experience for the programmer.");
	textprintf_ex(GameBitmaps[BUF_HOLD], (FONT*) GameDat[KingsQ_12].dat, 95, 386, DK_GRAY, -1,   "The code is considered open source and can be used and/or altered");
	textprintf_ex(GameBitmaps[BUF_HOLD], (FONT*) GameDat[KingsQ_12].dat, 95, 398, DK_GRAY, -1, "as desired but it is not to be sold.");
	textprintf_ex(GameBitmaps[BUF_HOLD], (FONT*) GameDat[KingsQ_12].dat, 200, 424, BR_RED, -1,    "Space Bar to Return to Title Screen");

	while(resp != KEY_SPACE)
          resp = dragons(GameBitmaps, GameDat); //  ReadKey function for Resp for desired actions

} // End Credits()*/

/**************** Function for Screens Key Reads  **************************/
int dragons(BITMAP* GameBitmaps[], DATAFILE *GameDat) {
	static int count = 0;
	static int loop_status = 0;
	int resp = 0;

	clear_keybuf();

//	while (resp != parm1 && resp != parm2 && resp != parm3 && resp != 'P'&& resp !=' ') {
		while (!keypressed()) {

			blit(GameBitmaps[BUF_HOLD], GameBitmaps[BUFFER], 0, 0, 0, 0, 640,
					480);

			if (loop_status == 0) {
				count++;
				draw_sprite(GameBitmaps[BUFFER],
						(BITMAP *) GameDat[DRAGON_LH].dat, 530 - count, 420);
				draw_sprite(GameBitmaps[BUFFER],
						(BITMAP *) GameDat[DRAGON_RH].dat, 90 + count, 420);
			} //End Loop Status 0

			if (count > 440)
				loop_status = 1;

			if (loop_status == 1) {
				count--;
				draw_sprite(GameBitmaps[BUFFER],
						(BITMAP *) GameDat[DRAGON_RH].dat, 530 - count, 420);
				draw_sprite(GameBitmaps[BUFFER],
						(BITMAP *) GameDat[DRAGON_LH].dat, 90 + count, 420);
			} // End Loop Status 1

			if (count <= 0)
				loop_status = 0;
			rest(5);

			blit(GameBitmaps[BUFFER], screen, 0, 0, 0, 0, 640, 480);
		} //while pressed
		resp = readkey();
		resp =  resp>>8;
//	} //end char check while
	return (resp);

}
